/* Monosynth - channel 1 1-Byte Data transfer CMC control
 *    reverse logic.    - Started as Mono synth - channel 1 
 * Sends: MIDI Note number to play or Bit 7 ON(128) to turn off note
 *        Uses Cassette Motor Control for flow control
 *        Reverse Logic for start up to allow MaxCart program sellection.
 *  Kevin Packard November 2019      
*/
// Atari PORTA(54016) mapped to pins on arduino
int porta0 = 4;
int porta1 = 5;
int porta2 = 6;
int porta3 = 7;
int porta4 = 8;
int porta5 = 9;
int porta6 = 10;
int porta7 = 11;
int DSR = 3; //data set ready trigger
int DTR = 13;//Atari ready cmc
byte zero = 0;
byte midiData = 0;
byte midiCommand = 0;
byte midiNoteNum = 0;
byte lastMidiNoteNum = 0;
byte volume = 0;
byte volOff = 0;

//Function to Send a byte to the Atari 
void sendByte(byte byteToSend){
  setPorta(byteToSend);
  digitalWrite(DSR,HIGH); //data ready-Trigger 0
  while(digitalRead(DTR) == LOW){} //Wait for Atari to get byte cmc goes low
  digitalWrite(DSR,LOW); //data not ready-trigger 1 
  while(digitalRead(DTR) == HIGH){} //wait for Atari to signal ok to get next byte
}

void setPorta(byte byteToMap){
  // Sets digital pins to transfer data to Atari joystick ports(PORTA)
  // When digital port high, joystick pin shorted to ground or logic 0
  if (byteToMap & B00000001){digitalWrite(porta0,HIGH);}
    else {digitalWrite(porta0,LOW);}
  if (byteToMap & B00000010){digitalWrite(porta1,HIGH);}
    else {digitalWrite(porta1,LOW);}
  if (byteToMap & B00000100){digitalWrite(porta2,HIGH);}
    else {digitalWrite(porta2,LOW);}
  if (byteToMap & B00001000){digitalWrite(porta3,HIGH);}
    else {digitalWrite(porta3,LOW);}
  if (byteToMap & B00010000){digitalWrite(porta4,HIGH);}
    else {digitalWrite(porta4,LOW);}
  if (byteToMap & B00100000){digitalWrite(porta5,HIGH);}
    else {digitalWrite(porta5,LOW);}
  if (byteToMap & B01000000){digitalWrite(porta6,HIGH);}
    else {digitalWrite(porta6,LOW);}
  if (byteToMap & B10000000){digitalWrite(porta7,HIGH);}
    else {digitalWrite(porta7,LOW);}
}

void setup() {
  pinMode(porta0,OUTPUT);
  pinMode(porta1,OUTPUT);
  pinMode(porta2,OUTPUT);
  pinMode(porta3,OUTPUT);
  pinMode(porta4,OUTPUT);
  pinMode(porta5,OUTPUT);
  pinMode(porta6,OUTPUT);
  pinMode(porta7,OUTPUT);
  pinMode(DSR,OUTPUT);
  pinMode(DTR,INPUT);
  Serial.begin(31250);
  setPorta(zero);//
  digitalWrite(DSR,LOW);
}

void loop() {     //read data until its a Midi command
                  //command bytes will have bit 7 true
    while (midiCommand != 128 && midiCommand != 144){   //midi command + Channel
    while(Serial.available()<1){}//wait for data
    midiCommand = Serial.read(); //read MIDI stream
  }
   // get data required by command.   
    while(Serial.available()<1){}
    midiNoteNum =  Serial.read();
    while(Serial.available()<1){}
    volume = Serial.read();

    if(midiNoteNum == lastMidiNoteNum && ((midiCommand == 128) ||  (midiCommand == 144 && volume == 0))){
     sendByte(volOff);
     lastMidiNoteNum = 0;
    }

    if(midiCommand == 144 && volume > 0 && midiNoteNum != lastMidiNoteNum){
      sendByte(midiNoteNum);
      lastMidiNoteNum = midiNoteNum;  
    }
    
    midiCommand = 0;
  }// End of Listing
